Description#
Given a 1-indexed array of integers numbers
that is already sorted in non-decreasing order, find two numbers such that they add up to a specific target
number. Let these two numbers be numbers[index1]
and numbers[index2]
where 1 <= index1 < index2 <= numbers.length
.
Return the indices of the two numbers, index1
and index2
, added by one as an integer array [index1, index2]
of length 2.
The tests are generated such that there is exactly one solution. You may not use the same element twice.
Your solution must use only constant extra space.
Example 1:
Input: numbers = [2,7,11,15], target = 9
Output: [1,2]
Explanation: The sum of 2 and 7 is 9. Therefore, index1 = 1, index2 = 2. We return [1, 2].
Example 2:
Input: numbers = [2,3,4], target = 6
Output: [1,3]
Explanation: The sum of 2 and 4 is 6. Therefore index1 = 1, index2 = 3. We return [1, 3].
Example 3:
Input: numbers = [-1,0], target = -1
Output: [1,2]
Explanation: The sum of -1 and 0 is -1. Therefore index1 = 1, index2 = 2. We return [1, 2].
Constraints:
2 <= numbers.length <= 3 * 104
-1000 <= numbers[i] <= 1000
numbers
is sorted in non-decreasing order.-1000 <= target <= 1000
- The tests are generated such that there is exactly one solution.
Solutions#
Solution 1: Binary Search#
Note that the array is sorted in non-decreasing order, so for each numbers[i]
, we can find the position of target - numbers[i]
by binary search, and return $[i + 1, j + 1]$ if it exists.
The time complexity is $O(n \times \log n)$, where $n$ is the length of the array numbers
. The space complexity is $O(1)$.
1
2
3
4
5
6
7
8
| class Solution:
def twoSum(self, numbers: List[int], target: int) -> List[int]:
n = len(numbers)
for i in range(n - 1):
x = target - numbers[i]
j = bisect_left(numbers, x, lo=i + 1)
if j < n and numbers[j] == x:
return [i + 1, j + 1]
|
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
| class Solution {
public int[] twoSum(int[] numbers, int target) {
for (int i = 0, n = numbers.length;; ++i) {
int x = target - numbers[i];
int l = i + 1, r = n - 1;
while (l < r) {
int mid = (l + r) >> 1;
if (numbers[mid] >= x) {
r = mid;
} else {
l = mid + 1;
}
}
if (numbers[l] == x) {
return new int[] {i + 1, l + 1};
}
}
}
}
|
1
2
3
4
5
6
7
8
9
10
11
12
| class Solution {
public:
vector<int> twoSum(vector<int>& numbers, int target) {
for (int i = 0, n = numbers.size();; ++i) {
int x = target - numbers[i];
int j = lower_bound(numbers.begin() + i + 1, numbers.end(), x) - numbers.begin();
if (j < n && numbers[j] == x) {
return {i + 1, j + 1};
}
}
}
};
|
1
2
3
4
5
6
7
8
9
| func twoSum(numbers []int, target int) []int {
for i, n := 0, len(numbers); ; i++ {
x := target - numbers[i]
j := sort.SearchInts(numbers[i+1:], x) + i + 1
if j < n && numbers[j] == x {
return []int{i + 1, j + 1}
}
}
}
|
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
| function twoSum(numbers: number[], target: number): number[] {
const n = numbers.length;
for (let i = 0; ; ++i) {
const x = target - numbers[i];
let l = i + 1;
let r = n - 1;
while (l < r) {
const mid = (l + r) >> 1;
if (numbers[mid] >= x) {
r = mid;
} else {
l = mid + 1;
}
}
if (numbers[l] === x) {
return [i + 1, l + 1];
}
}
}
|
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
| use std::cmp::Ordering;
impl Solution {
pub fn two_sum(numbers: Vec<i32>, target: i32) -> Vec<i32> {
let n = numbers.len();
let mut l = 0;
let mut r = n - 1;
loop {
match (numbers[l] + numbers[r]).cmp(&target) {
Ordering::Less => {
l += 1;
}
Ordering::Greater => {
r -= 1;
}
Ordering::Equal => {
break;
}
}
}
vec![(l as i32) + 1, (r as i32) + 1]
}
}
|
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
| /**
* @param {number[]} numbers
* @param {number} target
* @return {number[]}
*/
var twoSum = function (numbers, target) {
const n = numbers.length;
for (let i = 0; ; ++i) {
const x = target - numbers[i];
let l = i + 1;
let r = n - 1;
while (l < r) {
const mid = (l + r) >> 1;
if (numbers[mid] >= x) {
r = mid;
} else {
l = mid + 1;
}
}
if (numbers[l] === x) {
return [i + 1, l + 1];
}
}
};
|
Solution 2: Two Pointers#
We define two pointers $i$ and $j$, which point to the first element and the last element of the array respectively. Each time we calculate $numbers[i] + numbers[j]$. If the sum is equal to the target value, return $[i + 1, j + 1]$ directly. If the sum is less than the target value, move $i$ to the right by one position, and if the sum is greater than the target value, move $j$ to the left by one position.
The time complexity is $O(n)$, where $n$ is the length of the array numbers
. The space complexity is $O(1)$.
1
2
3
4
5
6
7
8
9
10
11
| class Solution:
def twoSum(self, numbers: List[int], target: int) -> List[int]:
i, j = 0, len(numbers) - 1
while i < j:
x = numbers[i] + numbers[j]
if x == target:
return [i + 1, j + 1]
if x < target:
i += 1
else:
j -= 1
|
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
| class Solution {
public int[] twoSum(int[] numbers, int target) {
for (int i = 0, j = numbers.length - 1;;) {
int x = numbers[i] + numbers[j];
if (x == target) {
return new int[] {i + 1, j + 1};
}
if (x < target) {
++i;
} else {
--j;
}
}
}
}
|
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
| class Solution {
public:
vector<int> twoSum(vector<int>& numbers, int target) {
for (int i = 0, j = numbers.size() - 1;;) {
int x = numbers[i] + numbers[j];
if (x == target) {
return {i + 1, j + 1};
}
if (x < target) {
++i;
} else {
--j;
}
}
}
};
|
1
2
3
4
5
6
7
8
9
10
11
12
13
| func twoSum(numbers []int, target int) []int {
for i, j := 0, len(numbers)-1; ; {
x := numbers[i] + numbers[j]
if x == target {
return []int{i + 1, j + 1}
}
if x < target {
i++
} else {
j--
}
}
}
|
1
2
3
4
5
6
7
8
9
10
11
12
13
| function twoSum(numbers: number[], target: number): number[] {
for (let i = 0, j = numbers.length - 1; ; ) {
const x = numbers[i] + numbers[j];
if (x === target) {
return [i + 1, j + 1];
}
if (x < target) {
++i;
} else {
--j;
}
}
}
|
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
| /**
* @param {number[]} numbers
* @param {number} target
* @return {number[]}
*/
var twoSum = function (numbers, target) {
for (let i = 0, j = numbers.length - 1; ; ) {
const x = numbers[i] + numbers[j];
if (x === target) {
return [i + 1, j + 1];
}
if (x < target) {
++i;
} else {
--j;
}
}
};
|